{
  Fonctions d'impression utilisant l'interruption n 17h (bios) tel que
  dcrit dans 'La Bible PC programmation systme' (ditions Micro Application)
  page 621  625 (4me dition)

  Remplace l'utilisation de la mthode clasique et vite ainsi le bloquage de
  Windows 95 (compatible avec BARRES de Worthington).

    mthode classique ne fonctionnant pas sous Windows 95

    var
      FPrn : Text;
    begin
      try
        AssignFile(FPrn, 'LPT1');
        Rewrite(FPrn);
        Writeln(FPrn, 'TEST');
      except
        on EIOError do MessageDlg('Erreur !', mtWarning, [mbOK], 0);
      end;
      CloseFile(Fprn);
    end;

    nouvelle mthode (ajouter  la clause 'uses' l'unit 'Imprimer')

    begin
      try
        prn_open(prn_LPT1);
        prn_writeln(prn_LPT1, 'TEST');
      except
        on EPrinterError do MessageDlg('Erreur !', mtWarning, [mbOK], 0);
      end;
      prn_close(prn_LPT1);
    end;

}

unit Imprimer;

interface

uses
  SysUtils, Controls, Forms, Dialogs;

const
  prn_LPT1=0;
  prn_LPT2=1;
  prn_LPT3=2;

type
  EPrinterError=class(Exception);

function prn_stt(lpt: word): integer;
function prn_open(lpt: word): integer;
procedure prn_close(lpt: word);
function prn_chr(lpt: word; car: char): integer;
function prn_write(lpt: word; txt: string): boolean;
function prn_writeln(lpt: word; txt: string): boolean;
procedure prn_timeout(lpt: word; val: byte);

implementation

var
  prn_TIME: array[prn_LPT1..prn_LPT3] of Byte;
  prn_MEMO: array[prn_LPT1..prn_LPT3] of Byte;

{
  prn_stt
  ------- lecture de l'tat de l'imprimante

  lpt : 0  2 <=> LPT1  LPT3

                        bit
  prn_stt ( integer )     7  6  5  4  3  2  1  0
                          0  1  1  1  1  X  X  1
                          |  |  |  |  |        |
                          |  |  |  |  |        Time Out
                          |  |  |  |  erreur de transmission
                          |  |  |  imprimante ON LINE
                          |  |  plus de papier
                          |  accus de rception (=1 aucune imprimante branch)
                          imprimante occupe

}
function prn_stt(lpt: word): integer;
var
  res: char;
begin
  asm
    mov ah,$02
    mov dx,lpt
    int $17
    mov res,ah
  end;
  prn_stt:=ord(res);
end;

{
  prn_open
  -------- initialistion du port parallle

  lpt : 0  2 <=> LPT1  LPT3
}
function prn_open(lpt: word): integer;
var
  tmp: longint;
  ini,
  val: byte;
  res: char;
begin
  tmp:=$40007800+lpt;
  val:=prn_TIME[lpt];

  asm
//    mov EAX,tmp
//    mov ah,[EAX]
//    mov ini,AH
//    mov AH,val
//    mov [EAX],ah
    mov ah,$01
    mov dx,lpt
    int $17
    mov res,ah
  end;
//  prn_MEMO[lpt]:=ini;
  prn_open:=ord(res);
end;

{
  prn_close
  --------- restitution valeur time-out LPT

  lpt : 0  2 <=> LPT1  LPT3
}
procedure prn_close(lpt: word);
var
  tim: ^Byte;
  val: Byte;
  tmp: longint;
begin
  tmp:=$40007800+lpt;
  val:=prn_MEMO[lpt];
  asm
//    mov EAX,tmp
//    mov AH,val
//    mov [EAX],AH
  end;
end;


{
  prn_chr
  ------- impression d'un caractre

  lpt : 0  2 <=> LPT1  LPT3
  car : caractre  imprimer

   prn_chr ( integer ) idem prn_stt
}
function prn_chr(lpt: word; car: char): integer;
var
  res: char;
begin
  asm
    mov ah,$00
    mov al,car
    mov dx,lpt
    int $17
    mov res,ah
  end;
  prn_chr:=ord(res);
end;


{
   prn_write
   --------- impression d'une chane de texte avec gestion des erreurs

   lpt : 0  2 <=> LPT1  LPT3

   prn_write ( boolean ) : impression correctement effectue
}
function prn_write(lpt: word; txt: string): boolean;
var
  res: integer;
  ind,
  len,
  sec: integer;
  cnt: boolean;
  tim,
  mem: string;
begin
  ind:=1;
  cnt:=True;
  len:=length(txt);
  res:=prn_stt(lpt);
  while (ind<=len) and cnt do
  begin
    mem:=TimeToStr(Time);
    sec:=4;
    repeat
      cnt:=( ( (res and $20)= 0 ) and
             ( (res and $80)<>0 ) and
             ( (res and $10)<>0 ) );
      tim:=TimeToStr(Time);
      if tim<>mem then
      begin
        mem:=tim;
        dec(sec);
      end;
      res:=prn_stt(lpt);

      if not cnt and (sec=0) then
        if MessageDlg('L''imprimante LPT'+chr(49+lpt)+' est hors service.',
                      mtError, [ mbCancel, mbRetry ], 0)=mrRetry then
          sec:=4
        else
          raise EPrinterError.Create('L''imprimante LPT'+chr(49+lpt)+' est hors service.');

    until cnt or (not cnt and (sec=0));
    if cnt then
    begin
      res:=prn_chr(lpt, txt[ind]);
      inc(ind);
    end;
  end;
  prn_write:=cnt;
end;

{
   prn_writeln
   ----------- impression d'une chane de texte avec gestion des erreurs

   lpt : 0  2 <=> LPT1  LPT3

   prn_writeln ( boolean ) : impression correctement effectue
}
function prn_writeln(lpt: word; txt: string): boolean;
begin
  prn_writeln:=prn_write(lpt, txt+#13#10);
end;

{
   prn_timeout
   ----------- fixe le dlai de time-out du port LPT

   lpt : 0  2 <=> LPT1  LPT3
   val : dlai de 2  20
}
procedure prn_timeout(lpt: word; val: byte);
begin
  prn_TIME[lpt]:=val;
end;


initialization

prn_TIME[prn_LPT1]:=2;
prn_TIME[prn_LPT2]:=2;
prn_TIME[prn_LPT3]:=2;

end.
